import pygame
from Champs import *
import numpy as np

RAYON_MUR_INVISIBLE = 2000

class Game:
    def __init__ (self, screen):
        self.screen = screen
        self.screenSize = np.array(self.screen.get_size())
        self.score = 0
        self.money = 10000
        self.displayMoney = 10000
        self.month = "janvier"
        #self.champs = [Houblon((-600,0)), Houblon((-300,0)), Houblon((100,0)), Houblon((300,0))
        #Houblon((-800,-200)), Houblon((-500,-200)), Buisson((-200,-200)), Buisson((100,-200)), Buisson((400,-200)),
        self.champs=[]
        for i in range(12):
            if i in (8,9,10):
                self.champs.append(Houblon(((i%4)*300-550,(i//4)*200-300)))
            else:
                self.champs.append(Buisson(((i%4)*300-550,(i//4)*200-300)))

        #Houblon((100,100)), Houblon((400,100)), Houblon((700,100)), Houblon((100,300)), Houblon((400,300)), Houblon((700,300)), Houblon((100,500)), Houblon((400,500)), Buisson((700,500))]
        self.clock = pygame.time.Clock()
        self.selectedChamp = None
        self.imageMoney = pygame.image.load("../assets/money.png")
        self.imageMoney = pygame.transform.scale(self.imageMoney, np.array(self.imageMoney.get_size())/3)
        self.police = pygame.font.SysFont("Alef", 30)
        self.camera = Camera(np.array(self.screen.get_size())/2)
        self.background = pygame.image.load('../assets/terre.png')
        self.background = pygame.transform.scale(self.background, (self.screen.get_width(), self.screen.get_height()))
        self.pluie = pygame.image.load('../assets/pluie.png')
        self.pluie = pygame.transform.scale(self.pluie, (200,200))
        self.flecheChangementscene = pygame.image.load("../assets/flecheScene.png")
        self.flecheChangementscene = pygame.transform.scale(self.flecheChangementscene, (100,100))
        self.coordonnee_image = self.screenSize[0]-self.flecheChangementscene.get_width() - 10 ,self.screenSize[1]/2
        self.rectangle_button_fleche = pygame.rect.Rect(*self.coordonnee_image,100,100)
        self.grange = pygame.image.load('../assets/grange.webp')
        self.grange = pygame.transform.scale(self.grange, (self.screen.get_width(), self.screen.get_height()))
        self.frame = 0
        self.buyFrame = -1000
    
    def gameLoop (self):
        while True:
            self.screen.blit(self.background, (0,0))

            # Météo
            self.carre_meteo = pygame.draw.rect(self.screen, (127, 127, 127), (0, self.screen.get_height() - 200 , 200, 200))
            self.screen.blit(self.pluie, (0, self.screen.get_height()-200))
            
                

            isChamp = False
            # Affichage des champs
            for champ in self.champs:
                champ.draw(self.screen, self.camera)

            # Affiche les fps
            fpsText = self.police.render(("%.0f fps" %(self.clock.get_fps())), True, (180,180,180))
            self.screen.blit(fpsText, (self.screen.get_width() - fpsText.get_width(), 0))

            # somme ajoutée ou enlevée au-dessus puis s'ajoute

            if self.money < self.displayMoney:
                self.displayMoney -= 100 # Si quelque chose coûte moins que 100, changer par -= min(100, self.displayMoney - self.money)
            elif self.money > self.displayMoney:
                self.displayMoney += 100 # Si quelque chose coûte moins que 100, changer par -= min(100, self.money - self.displayMoney)

            textMoney = self.police.render(str(self.displayMoney), True, (255,255,255))
            self.screen.blit(textMoney, (210, self.screen.get_height()-textMoney.get_height()*2))
            self.screen.blit(self.imageMoney, (220+textMoney.get_width(), self.screen.get_height()-self.imageMoney.get_height()))

            print(self.clock.get_time())
            print(self.clock.get_rawtime())

                        
            self.screen.blit(self.flecheChangementscene, self.coordonnee_image)
           
            for event in pygame.event.get():
                if event.type == pygame.QUIT or event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                    exit()
                elif event.type == pygame.MOUSEBUTTONDOWN and (*event.pos,0,0) in self.rectangle_button_fleche:
                    self.gameLoopSecondScreen()
                elif event.type == pygame.MOUSEMOTION:
                    if event.buttons[2] == 1: #maintenir enfoncé clic droit
                        self.camera.setPosition(np.array(event.rel))

                    for champ in self.champs:
                        if champ.rectScale.contains(event.pos[0],event.pos[1],0,0):
                            self.selectedChamp = champ
                            isChamp = True
                
                    if not isChamp:
                        self.selectedChamp = None
                
                elif event.type == pygame.MOUSEWHEEL:
                    self.camera.zoomInOut(event.y)

                # Achat d'un champ
                elif event.type == pygame.MOUSEBUTTONDOWN:
                    if event.button == 1:
                        for champ in self.champs:
                            if isinstance(champ, Buisson):
                                if champ.rectScale.contains(event.pos[0],event.pos[1],0,0):
                                    if self.money >= champ.prix:
                                        self.moneyChange = self.police.render(str(-champ.prix), True, (255,0,0))

                                        self.buyFrame = self.frame
                                    
                                        self.champs.append(champ.buyField())
                                        self.champs.remove(champ)
                                        self.money -= champ.prix
                                    else:
                                        self.moneyError()
                                    

              

            if self.frame < self.buyFrame + 100:
                self.screen.blit(self.moneyChange, (210, self.screen.get_height()-textMoney.get_height()*4-(self.frame-self.buyFrame)*1.25))

            if self.selectedChamp:
                self.selectedChamp.showInfo(self.screen, self.camera)

            if self.carre_meteo.collidepoint(pygame.mouse.get_pos()):
  
                self.showInfoWeatherInterface()
     

            pygame.display.update()
            self.clock.tick(50)
            self.frame += 1

    def moneyError (self):
        loop = True
        while loop:
            popUp = pygame.draw.rect(self.screen, (0,0,0), (self.screenSize/3, self.screenSize/3))

            for event in pygame.event.get(pygame.MOUSEBUTTONDOWN):
                if popUp.contains((*event.pos,0,0)):
                    loop = False
                    break

            pygame.display.update()
            self.clock.tick(50)

    def showInfoWeatherInterface(self):
        estFini = self.carre_meteo.collidepoint(pygame.mouse.get_pos())
        popUp = pygame.draw.rect(self.screen, (20,125,125,0.5), (self.screenSize/3, self.screenSize/3))
        while True:
            
            for event in pygame.event.get(pygame.MOUSEMOTION):
                if (*event.pos,0,0) not in popUp:
                    return 
                

        pygame.display.update()
        self.clock.tick(50)
        
    def gameLoopSecondScreen (self):
        while True:
            self.screen.blit(self.grange, (0,0))

            for event in pygame.event.get():
                if event.type == pygame.QUIT or event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                    exit()
                elif event.type == pygame.KEYDOWN and event.key == pygame.K_LEFT:
                    return

            pygame.display.update()
            self.clock.tick(50)
                

class Camera:
    def __init__ (self, screenMid):
        self.mid = screenMid
        self.zoom = 1 # zoom actuel
        self.lastZoom = 1.1 # dernier zoom
        self.position = np.array([0,0]) # position du point visé (ici le milieu de l'écran)

    def convertLocation (self, c1:np.array)->np.array: # Convertie les coordonnées de l'écran en coordonnées sur le jeu
        c2 = (c1 * self.zoom) + self.mid + (self.position * self.zoom)
        return c2

    def changeScreenLocation (self, c2:np.array)->np.array: # Convertie les coordonnées du jeu en coordonnées de l'écran
        c1 = (c2 - self.mid - (self.position / self.zoom)) / self.zoom
        return c1

    def zoomInOut (self, y): # Zoom en fonction de la molette
        self.lastZoom = self.zoom
        self.zoom += y*0.1

        self.zoom = np.clip(self.zoom, 0.3, 2) # zoom min max

    def setPosition (self, positionRelative): # Calcule la nouvelle position de l'écran
        newPos = self.position + positionRelative

        # Pour faire un carré (mur invisible) : 
        self.position = np.clip(newPos, [-1000, -1000], [1000, 1000])

        # Pour faire un cercle :
        #if np.linalg.norm(newPos) < RAYON_MUR_INVISIBLE:
            #self.position = newPos

    def __repr__ (self):
        return f"Zoom = {self.zoom}\nPosition = {self.position}\n"

    def scaleImage (self, img): # Change le zoom d'une image si nécessaire
        if self.zoom != self.lastZoom:
            return pygame.transform.scale(img, np.array(img.get_size())*self.zoom)

        return None